CREATE DATABASE ProdavnicaArtikala
go

Use ProdavnicaArtikala
go

CREATE TABLE [Artikal]
( 
	[Id]                 integer  NOT NULL  IDENTITY ,
	[Naziv]              char(18)  NULL ,
	[IdP]                integer  NOT NULL ,
	[CenaNabavna]        decimal(10,2)  NULL ,
	[CenaProdajna]       decimal(10,2)  NULL 
)
go

ALTER TABLE [Artikal]
	ADD CONSTRAINT [XPKArtikal] PRIMARY KEY  CLUSTERED ([Id] ASC)
go

CREATE TABLE [ArtikalUMagacinu]
( 
	[Id]                 integer  NOT NULL  IDENTITY ,
	[IdM]                integer  NOT NULL ,
	[IdA]                integer  NOT NULL 
)
go

ALTER TABLE [ArtikalUMagacinu]
	ADD CONSTRAINT [XPKArtikalUMagacinu] PRIMARY KEY  CLUSTERED ([Id] ASC)
go

CREATE TABLE [Drzava]
( 
	[Id]                 integer  NOT NULL  IDENTITY ,
	[Naziv]              char(18)  NULL 
)
go

ALTER TABLE [Drzava]
	ADD CONSTRAINT [XPKDrzava] PRIMARY KEY  CLUSTERED ([Id] ASC)
go

CREATE TABLE [Grad]
( 
	[Id]                 integer  NOT NULL  IDENTITY ,
	[IdD]                integer  NOT NULL ,
	[Naziv]              char(18)  NULL 
)
go

ALTER TABLE [Grad]
	ADD CONSTRAINT [XPKGrad] PRIMARY KEY  CLUSTERED ([Id] ASC)
go

CREATE TABLE [Korisnik]
( 
	[Id]                 integer  NOT NULL  IDENTITY ,
	[IdG]                integer  NOT NULL ,
	[email]              char(18)  NULL ,
	[sifra]              char(18)  NULL 
)
go

ALTER TABLE [Korisnik]
	ADD CONSTRAINT [XPKKorisnik] PRIMARY KEY  CLUSTERED ([Id] ASC)
go

CREATE TABLE [Korpa]
( 
	[Id]                 integer  NOT NULL  IDENTITY ,
	[IdKup]              integer  NOT NULL ,
	[Status]             char(18)  NULL 
)
go

ALTER TABLE [Korpa]
	ADD CONSTRAINT [XPKKorpa] PRIMARY KEY  CLUSTERED ([Id] ASC)
go

CREATE TABLE [Kupac]
( 
	[Id]                 integer  NOT NULL ,
	[Ime]                char(18)  NULL 
)
go

ALTER TABLE [Kupac]
	ADD CONSTRAINT [XPKKupac] PRIMARY KEY  CLUSTERED ([Id] ASC)
go

CREATE TABLE [Magacin]
( 
	[Id]                 integer  NOT NULL  IDENTITY ,
	[Naziv]              char(18)  NULL ,
	[Kapacitet]          int  NULL 
)
go

ALTER TABLE [Magacin]
	ADD CONSTRAINT [XPKMagacin] PRIMARY KEY  CLUSTERED ([Id] ASC)
go

CREATE TABLE [Prodavnica]
( 
	[Id]                 integer  NOT NULL ,
	[Naziv]              char(18)  NULL 
)
go

ALTER TABLE [Prodavnica]
	ADD CONSTRAINT [XPKProdavnica] PRIMARY KEY  CLUSTERED ([Id] ASC)
go

CREATE TABLE [UKorpi]
( 
	[Id]                 integer  NOT NULL  IDENTITY ,
	[IdKor]              integer  NOT NULL ,
	[IdAM]               integer  NOT NULL 
)
go

ALTER TABLE [UKorpi]
	ADD CONSTRAINT [XPKUKorpi] PRIMARY KEY  CLUSTERED ([Id] ASC)
go


ALTER TABLE [Artikal]
	ADD CONSTRAINT [R_17] FOREIGN KEY ([IdP]) REFERENCES [Prodavnica]([Id])
		ON DELETE NO ACTION
		ON UPDATE NO ACTION
go


ALTER TABLE [ArtikalUMagacinu]
	ADD CONSTRAINT [R_1] FOREIGN KEY ([IdM]) REFERENCES [Magacin]([Id])
		ON DELETE NO ACTION
		ON UPDATE NO ACTION
go

ALTER TABLE [ArtikalUMagacinu]
	ADD CONSTRAINT [R_2] FOREIGN KEY ([IdA]) REFERENCES [Artikal]([Id])
		ON DELETE NO ACTION
		ON UPDATE NO ACTION
go


ALTER TABLE [Grad]
	ADD CONSTRAINT [R_8] FOREIGN KEY ([IdD]) REFERENCES [Drzava]([Id])
		ON DELETE NO ACTION
		ON UPDATE NO ACTION
go


ALTER TABLE [Korisnik]
	ADD CONSTRAINT [R_10] FOREIGN KEY ([IdG]) REFERENCES [Grad]([Id])
		ON DELETE NO ACTION
		ON UPDATE NO ACTION
go


ALTER TABLE [Korpa]
	ADD CONSTRAINT [R_5] FOREIGN KEY ([IdKup]) REFERENCES [Kupac]([Id])
		ON DELETE NO ACTION
		ON UPDATE NO ACTION
go


ALTER TABLE [Kupac]
	ADD CONSTRAINT [R_4] FOREIGN KEY ([Id]) REFERENCES [Korisnik]([Id])
		ON DELETE CASCADE
		ON UPDATE CASCADE
go


ALTER TABLE [Prodavnica]
	ADD CONSTRAINT [R_3] FOREIGN KEY ([Id]) REFERENCES [Korisnik]([Id])
		ON DELETE CASCADE
		ON UPDATE CASCADE
go


ALTER TABLE [UKorpi]
	ADD CONSTRAINT [R_6] FOREIGN KEY ([IdKor]) REFERENCES [Korpa]([Id])
		ON DELETE NO ACTION
		ON UPDATE NO ACTION
go

ALTER TABLE [UKorpi]
	ADD CONSTRAINT [R_16] FOREIGN KEY ([IdAM]) REFERENCES [ArtikalUMagacinu]([Id])
		ON DELETE NO ACTION
		ON UPDATE NO ACTION
go
