Use ProdavnicaArtikala
go

create role roleMesta
go
create role roleKorisnici
go
create role roleMagacini
go
create role roleArtikli
go
create role roleProdaja
go
create role roleAnaliza
go

if not exists(select * from master.dbo.syslogins where loginname = 'KorisnikAdmin')
create login KorisnikAdmin with password = '123'
go

if not exists(select * from master.dbo.syslogins where loginname = 'MagaciniArtikliAdmin')
create login MagaciniArtikliAdmin with password = '123'
go

if not exists(select * from master.dbo.syslogins where loginname = 'ProdajaAdmin')
create login ProdajaAdmin with password = '123'
go

if not exists(select * from master.dbo.syslogins where loginname = 'AnalizaAdmin')
create login AnalizaAdmin with password = '123'
go

create user korisnik for login KorisnikAdmin
go
create user magaciniArtikli for login MagaciniArtikliAdmin
go
create user prodaja for login ProdajaAdmin
go
create user analiza for login AnalizaAdmin
go

alter role roleMesta add member korisnik
go
alter role roleKorisnici add member korisnik
go
alter role roleMagacini add member magaciniArtikli
go
alter role roleArtikli add member magaciniArtikli
go
alter role roleProdaja add member prodaja
go
alter role roleAnaliza add member analiza
go

create schema korisnici
go
create schema mesta
go
create schema magacini
go
create schema artikli
go
create schema prodaja
go

alter schema korisnici transfer object::dbo.Korisnik
alter schema korisnici transfer object::dbo.Prodavnica
alter schema korisnici transfer object::dbo.Kupac

alter schema mesta transfer object::dbo.Drzava
alter schema mesta transfer object::dbo.Grad

alter schema magacini transfer object::dbo.Magacin
alter schema artikli transfer object::dbo.Artikal
alter schema artikli transfer object::dbo.ArtikalUMagacinu

alter schema prodaja transfer object::dbo.Korpa
alter schema prodaja transfer object::dbo.UKorpi

grant control on schema::korisnici to roleKorisnici
go
grant create table to roleKorisnici
go
deny select on object::korisnici.korisnik(sifra) to roleKorisnici
go
grant control on schema::mesta to roleMesta
go
grant create table to roleMesta
go
grant control on schema::prodaja to roleProdaja
go
grant create table to roleProdaja
go
deny delete on schema::prodaja to roleProdaja
go
grant control on schema::magacini to roleMagacini
go
grant create table to roleMagacini
go
grant alter on schema::artikli to roleArtikli
go
grant create table to roleArtikli
go

CREATE VIEW dbo.Profit
AS
	select sum(A.CenaProdajna * (case when (AK.ID is null) then 0 else 1 end)) - sum(A.CenaNabavna) as Profit, A.IdP as Prodavnica
	from 
		artikli.Artikal A
		join artikli.ArtikalUMagacinu AM on AM.IdA = A.Id
		left outer join prodaja.UKorpi AK on AK.IdAM = AM.Id
		left outer join prodaja.Korpa K on K.Id = AK.IdKor
	where K.Status = 'kupljena'
	group by A.IdP
go

CREATE FUNCTION [dbo].[popunjenostMagacina]
(
    @idM int
) 
RETURNS decimal(10,2)
begin
RETURN (
    SELECT cast(cast(count(*) as decimal(10,2))/cast(M.Kapacitet as decimal(10,2)) as decimal(10,2)) as Procenat
	from 
	artikli.ArtikalUMagacinu AM
	join magacini.Magacin M on AM.IdM = M.Id
	where M.Id = @idM
	group by M.Id, M.Kapacitet
)
end
go

CREATE PROCEDURE dbo.brojKorisnikaPoGradu
AS
    SELECT G.Id as IdGrada, G.Naziv as NazivGrada, 
		D.Naziv as NazivDrzave, count(K.Id) as BrojKorisnika
	from 
	mesta.Grad G join mesta.Drzava D on G.IdD = D.Id
		left join korisnici.Korisnik K on K.IdG = G.Id
	group by G.Id, G.Naziv, D.Naziv
	
RETURN 0 
go

grant select on object::dbo.popunjenostMagacina to roleAnaliza
grant select on object::dbo.Profit to roleAnaliza
grant execute on object::dbo.brojKorisnikaPoGradu to roleAnaliza

grant select on object::magacini.Magacin to analiza

-- select * from dbo.Profit
-- select * from dbo.popunjenostMagacina(1)
-- execute dbo.brojKorisnikaPoGradu

ALTER AUTHORIZATION ON SCHEMA::korisnici TO korisnik;
